using System;
using iNTERFACEWARE.Chameleon;

class XmlExample : Log
{
    private static string MESSAGE_DEFINITION_FILE = "..\\..\\project.vmd";
    private DynamicEngine m_engine; 

    public XmlExample()
    {
        m_engine = new DynamicEngine();   
    }
    public void StartExample() 
    {
        try
        {        
            m_engine.AddLog(this);
            m_engine.Load(MESSAGE_DEFINITION_FILE);
            
            Println("We start with a flatwire message:");
            
            string FlatWire;
            FlatWire = "MSH|^~\\&|REGADT|MCM|RSP1P8|MCM|199601051530|SEC|ADT^A44|00000007|P|2.3\r";
            FlatWire = FlatWire + "EVN|A44|199601051530\r";
            FlatWire = FlatWire + "PID|||MR2^^^XYZ||JONES^WILLIAM^A^JR||19501010|M|||123 EAST STREET^^NY^NY^10021||(212)111-3333|||S||ACCT1\r";
            FlatWire = FlatWire + "MRG|MR1^^^XYZ||ACCT1\r";
            FlatWire = FlatWire + "MRG|MR1^^^XYZ||ACCT1\r";
            FlatWire = FlatWire + "MRG|MR1^^^XYZ||ACCT1\r";
         
            Println(m_engine.MakeMessagePrintable(FlatWire));
            
            // The TranslateMessageToXml method uses the XML Translation Scheme specified
            // in the Options -> XML settings of the message definition file.
            // Read the XML <-> HL7 Translation chapter of the manual for more information.
            string XmlFormat = m_engine.TranslateMessageToXml(FlatWire);     
            Println("Translated to XML:");
            Println(XmlFormat);
            
            // Same XML Translation Scheme as for TranslateMessageToXml above
            string Hl7 = m_engine.TranslateXmlToMessage(XmlFormat);
            Println("And translating back again...");
            Println(m_engine.MakeMessagePrintable(Hl7));

            Println("Press Enter to Exit...");
            System.Console.ReadLine();
        }
        catch (ChameleonException ex)
        {
            Println(ex.ToString());
        }
    }

    //Log interfase
    public void Println(string output_text) 
    {
        System.Console.WriteLine(output_text);		
    }
   
   
    public static void Main()
    {
        XmlExample Example = new XmlExample();
        Example.StartExample();
    }
}

